<?php
namespace Zeedhi\DevOps\Model\Projectmanagement\Repositories;


use Zeedhi\DevOps\Util\Utilities;

class Classification extends \Doctrine\ORM\EntityRepository {

    public function findClassifications($conditions,$organizationId){

        $conditionString = Utilities::createQueryFiltered($conditions);

        $sql = <<<SQL
        SELECT ID, LABEL, CONTROL,IS_PROJECT, IS_TASK,NOT_ALLOWED_PROJECT_TYPE,ALLOWED_PROJECT_TYPE,NOT_ALLOWED_PROJECT_STATUS, ESTIMATED_TIME_PROPORTION,
               ALLOWED_PROJECT_STATUS,NULL  AS "__is_new",DIVIDE_DURATION,USED_IN_TIME_CONTROL, NRPERFILACESSO, USED_IN_NEWS
        FROM (
               SELECT CLA.ID, CLA.LABEL, CLA.CONTROL, CLA.IS_PROJECT, CLA.IS_TASK, CLA.ESTIMATED_TIME_PROPORTION,CLA.DIVIDE_DURATION,CLA.USED_IN_TIME_CONTROL, CLA.USED_IN_NEWS,
                  (SELECT rtrim(xmlagg(xmlelement(e, CP.NRPERFILACESSO,',').extract('//text()') order by CP.NRPERFILACESSO).GetClobVal(),',')
                     FROM CLASSIFICATION_PERFILACESSO CP WHERE CP.CLASSIFICATION = CLA.ID) AS NRPERFILACESSO,
                  (SELECT (rtrim(xmlagg(xmlelement(e,CPT.PROJECT_TYPE,',').extract('//text()') order by CPT.ID).GetClobVal(),',')) AS IDS
                     FROM CLASSIFICATION_PROJECT_TYPE CPT WHERE CPT.CLASSIFICATION = CLA.ID AND CPT.TYPE = 'N') AS NOT_ALLOWED_PROJECT_TYPE,
                  (SELECT (rtrim(xmlagg(xmlelement(e,CPT.PROJECT_TYPE,',').extract('//text()') order by CPT.ID).GetClobVal(),',')) AS IDS
                     FROM CLASSIFICATION_PROJECT_TYPE CPT WHERE CPT.CLASSIFICATION = CLA.ID AND CPT.TYPE = 'P') AS ALLOWED_PROJECT_TYPE,
                  (SELECT (rtrim(xmlagg(xmlelement(e,CTS.TASK_STATUS,',').extract('//text()') order by CTS.ID).GetClobVal(),',')) AS IDS
                     FROM CLASSIFICATION_TASK_STATUS CTS WHERE CTS.CLASSIFICATION = CLA.ID AND CTS.TYPE = 'N') AS NOT_ALLOWED_PROJECT_STATUS,
                  (SELECT (rtrim(xmlagg(xmlelement(e,CTS.TASK_STATUS,',').extract('//text()') order by CTS.ID).GetClobVal(),',')) AS IDS
                     FROM CLASSIFICATION_TASK_STATUS CTS WHERE CTS.CLASSIFICATION = CLA.ID AND CTS.TYPE = 'P') AS ALLOWED_PROJECT_STATUS
                 FROM CLASSIFICATION CLA
                WHERE CLA.ORGANIZATION = :organizationId)
        WHERE 1 = 1
        $conditionString
SQL;

        $params = array(
            'organizationId' => $organizationId
        );
        return $this->getEntityManager()->getConnection()->fetchAll($sql, $params);
    }

    public function findClassificationForTask($projectStatus,$projectType,$organizationId, $filterString = ''){


        $sql = <<<SQL
        SELECT ID, LABEL, CONTROL,IS_PROJECT, IS_TASK, DIVIDE_DURATION
          FROM (
                  SELECT CLA.ID, CLA.LABEL, CLA.CONTROL, CLA.IS_PROJECT, CLA.IS_TASK, CLA.DIVIDE_DURATION
                    FROM CLASSIFICATION CLA
               LEFT JOIN CLASSIFICATION_TASK_STATUS CTS ON (CTS.CLASSIFICATION = CLA.ID AND CTS.TYPE = 'N' AND CTS.TASK_STATUS = :taskStatus)
               LEFT JOIN CLASSIFICATION_PROJECT_TYPE CPT ON (CPT.CLASSIFICATION = CLA.ID AND CPT.TYPE = 'N' AND  CPT.PROJECT_TYPE = :projectType)
                   WHERE CLA.ORGANIZATION = :organizationId
                     AND CLA.IS_TASK = 'Y'
                     AND ( CTS.ID IS NULL AND CPT.ID IS NULL )
                     AND  CLA.CONTROL IS NULL
                     $filterString
                ORDER BY CLA.LABEL
                )
SQL;

        $params = array(
            'organizationId' => $organizationId,
            'taskStatus' => $projectStatus,
            'projectType' => $projectType,
        );
        return $this->getEntityManager()->getConnection()->fetchAll($sql, $params);
    }
    public function findClassification($projectStatus,$projectType,$organizationId){


        $sql = <<<SQL
        SELECT ID, LABEL, CONTROL,IS_PROJECT, IS_TASK
          FROM (
                  SELECT CLA.ID, CLA.LABEL, CLA.CONTROL, CLA.IS_PROJECT, CLA.IS_TASK
                    FROM CLASSIFICATION CLA
               LEFT JOIN CLASSIFICATION_TASK_STATUS CTS ON (CTS.CLASSIFICATION = CLA.ID AND CTS.TYPE = 'N' AND CTS.TASK_STATUS = :taskStatus)
               LEFT JOIN CLASSIFICATION_PROJECT_TYPE CPT ON (CPT.CLASSIFICATION = CLA.ID AND CPT.TYPE = 'N' AND  CPT.PROJECT_TYPE = :projectType)
                   WHERE CLA.ORGANIZATION = :organizationId
                     AND CLA.IS_TASK = 'Y'
                     AND ( CTS.ID IS NULL AND CPT.ID IS NULL )
                     AND  CLA.CONTROL IS NULL
                ORDER BY CLA.LABEL
                )
SQL;

        $params = array(
            'organizationId' => $organizationId,
            'taskStatus' => $projectStatus,
            'projectType' => $projectType,
        );
        return $this->getEntityManager()->getConnection()->fetchAll($sql, $params);
    }
}